import React from 'react';
import { Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker } from 'antd';
import $ from 'jquery/src/ajax';
import moment from 'moment';
import '@/account/demand/techDemand.less';
import NewDesc from '@/administration/policy/policyDesc';
import '@/administration/news/news.less';
import {  } from '@/dataDic.js';
import {getReleaseStateList, } from '@/tools.js';

const PolicyList = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            page:pageNo,
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/policy/list",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                title: this.state.nameSearch, //政策标题
                startReleaseDate: this.state.releaseDate[0],
                endReleaseDate: this.state.releaseDate[1],
                auditStatus:this.state.auditStatusSearch,
            },
            success: function (data) {
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
                            id: thisdata.id,
                            title: thisdata.title,
                            author:thisdata.author,
                            source: thisdata.source,
                            auditStatus: thisdata.auditStatus, //审核状态
                            releaseDate:thisdata.releaseDate?(new Date(thisdata.releaseDate)).toLocaleString():''
                        });
                    };
                };
                this.state.selectedRowKeys=[];
                this.state.pagination.current = data.data.pageNo;
                this.state.pagination.total = data.data.totalCount;
                if(data.data&&data.data.list&&!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				};
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            searchMore: true,
            validityPeriodDate: [],
            releaseDate: [],
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '政策名称',
                    dataIndex: 'title',
                    key: 'title',
                },  {
                    title: '创建人',
                    dataIndex: 'author',
                    key: 'author',
                    render:text=>{return <span>管理员</span>}
                },
                {
                    title: '发布状态',
                    dataIndex: 'auditStatus',
                    key: 'auditStatus',
                    render: text => { return getReleaseStateList(text) }
                },
                {
                    title: '来源',
                    dataIndex: 'source',
                    key: 'source'
                },
                {
                    title: '发布时间',
                    dataIndex: 'releaseDate',
                    key: 'releaseDate'
                },
                {
                    title: '操作',
                    dataIndex: 'caozuo',
                    key: 'caozuo',
                    render:(text,recard) => {
                        return  <div className="btnRight">
                                   {recard.auditStatus!='1'&&recard.auditStatus!='2'&&<Button type="primary" style={{ background: "#3fcf9e", border: "none", color: "#fff" }} onClick={(e)=>{e.stopPropagation(),this.submission(recard)}}>发布</Button>}
                                   {recard.auditStatus!='1'&&recard.auditStatus=='2'&&<Button type="success" onClick={(e)=>{ e.stopPropagation(),this.updateFun(recard)}}>刷新发布</Button>}
                                   {recard.auditStatus!='1'&&recard.auditStatus=='2'&&<Button type="danger" onClick={(e)=>{e.stopPropagation(),this.revokeFun(recard)}}>撤销发布</Button>}
                                </div>
                    }
                }
            ],
            dataSource: [],
            searchTime: [,]
        };
    },
    //发布
    submission(record){
        this.setState({
            showDesc:false,
            loading:true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/policy/updateStatus",
            data: {
                id:record.id,
                auditStatus:2
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('发布成功.');
                this.setState({
                    loading: false,
                });
                this.loadData(this.state.page)
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    //刷新发布
    updateFun(recard){
        this.setState({
            loading:true
        })
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context +'/api/admin/policy/updateStatus',
            data: {
                id: recard.id,
                auditStatus:recard.auditStatus,
                refresh:1
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('刷新成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData(this.state.page);
        }.bind(this));
    },
    //撤销发布
    revokeFun(recard){
        this.setState({
            loading:true
        })
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context +  '/api/admin/policy/updateStatus',
            data: {
                id: recard.id,
                auditStatus:4,
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('撤销成功！');
                this.setState({
                    loading: false,
                });
                this.loadData(this.state.page);
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    delectRow() {
        this.setState({
            loading:true
        })
        let deletedIds =[];
        let rowItem = this.state.selectedRowKeys[0];
        let data = this.state.dataSource ||[];
        if (data.length) {
            deletedIds.push(data[rowItem].id);
        }
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/policy/delete",
            data: {
                id: deletedIds[0]
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('删除成功！');
                this.setState({
                    loading: false
                });
                this.loadData(this.state.page);
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    addClick() {
        this.state.RowData = {};
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.page);
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.nameSearch = '';
        this.state.releaseDate = [];
        this.state.dataCategorySearch = undefined;
        this.state.auditStatusSearch = undefined;
        this.loadData();
        
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows.slice(-1),
                    selectedRowKeys: selectedRowKeys.slice(-1)
                });
            }

        };
        const { RangePicker } = DatePicker;
        const hasSelect = this.state.selectedRowKeys.length;
        return (
            <div className="user-content" >
                <div className="content-title">
                    <span>政策管理</span>
                    <div className="patent-addNew">
                        <Button type="primary" onClick={this.addClick}>发布政策<Icon type="plus" /></Button>
                    </div>
                </div>
                <div className="user-search">
                    <Input placeholder="政策名称"
                        value={this.state.nameSearch}
                        onChange={(e) => { this.setState({ nameSearch: e.target.value }); }} />
                    <Select placeholder="发布状态" style={{ width: 120 }}
                        value={this.state.auditStatusSearch}
                        onChange={(e) => { this.setState({ auditStatusSearch: e }) }}>
                        <Select.Option value="0" >草稿</Select.Option>
                        <Select.Option value="2" >已发布</Select.Option>
                    </Select>
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>
                    <Button type="danger" disabled={!hasSelect}  onClick={(e)=>{this.delectRow()}}>删除</Button>
                    <span>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>
                    <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
                        <span>发布时间 :</span>
                        <RangePicker
                            value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
                            this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
                            onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />
                    </div>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            rowSelection={rowSelection}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <NewDesc
                    data={this.state.RowData}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc} />
            </div >
        );
    }
});

export default PolicyList;